java异常继承何类,运行时异常与一般异常的区别(详解)

转载  2017-11-13   投稿:jingxian   我要评论
下面小编就为大家带来一篇java异常继承何类,运行时异常与一般异常的区别(详解)。小编觉得挺不错的,现在就分享给大家,也给大家做个参考。一起跟随小编过来看看吧
一、基本概念 Throwable是所有异常的根,java.lang.Throwable Error是错误,java.lang.Error Exception是异常,java.lang.Exception Throwable 有两个重要的子类:Exception(异常)和 Error(错误),二者都是 Java 异常处理的重要子类,各自都包含大量子类。 Error(错误):是程序无法处理的错误,表示运行应用程序中较严重问题。大多数错误与代码编写者执行的操作无关,而表示代码运行时 JVM(Java 虚拟机)出现的问题。例如,Java虚拟机运行错误(Virtual MachineError),当 JVM 不再有继续执行操作所需的内存资源时,将出现 OutOfMemoryError。这些异常发生时,Java虚拟机(JVM)一般会选择线程终止。 这些错误表示故障发生于虚拟机自身、或者发生在虚拟机试图执行应用时,如Java虚拟机运行错误(Virtual MachineError)、类定义错误(NoClassDefFoundError)等。这些错误是不可查的,因为它们在应用程序的控制和处理能力之 外,而且绝大多数是程序运行时不允许出现的状况。对于设计合理的应用程序来说,即使确实发生了错误,本质上也不应该试图去处理它所引起的异常状况。在 Java中,错误通过Error的子类描述。 Exception(异常):是程序本身可以处理的异常。 Exception 类有一个重要的子类 RuntimeException。RuntimeException 类及其子类表示“JVM 常用操作”引发的错误。例如,若试图使用空值对象引用、除数为零或数组越界,则分别引发运行时异常(NullPointerException、ArithmeticException)和 ArrayIndexOutOfBoundException。 注意:异常和错误的区别:异常能被程序本身可以处理,错误是无法处理。 二、Exception 一般分为Checked异常和Runtime异常,所有RuntimeException类及其子类的实例被称为Runtime异常,不属于该范畴的异常则被称为CheckedException。 ①Checked异常 只有java语言提供了Checked异常,Java认为Checked异常都是可以被处理的异常,所以Java程序必须显示处理Checked异常。如果程序没有处理Checked异常,该程序在编译时就会发生错误无法编译。这体现了Java的设计哲学:没有完善错误处理的代码根本没有机会被执行。对Checked异常处理方法有两种 1 当前方法知道如何处理该异常,则用try...catch块来处理该异常。
2 当前方法不知道如何处理,则在定义该方法是声明抛出该异常。
package cn.xy.test; import java.io.IOException; /** * Checked异常测试方法 * @author xy * */ public class CheckedExceptionMethods { // 总异常类,既有checkedException又有RuntimeException,所以其中的checkedException必须处理 public void method1() throws Exception { System.out.println("我是抛出异常总类的方法"); } // 捕获并处理这个异常 public void testMethod1_01() { try { method1(); } catch (Exception e) { e.printStackTrace(); } } // 把异常传递下去 public void testMethod1_02() throws Exception { method1(); } public void testMethod1_03() throws Exception { throw new Exception(); } public void testMethod1_04() { try { throw new Exception(); } catch (Exception e) { e.printStackTrace(); } } // checkedException典型代表IOException public void method2() throws IOException { System.out.println("我是抛出IO异常的方法"); } public void testMethod2_01() { try { method2(); } catch (Exception e) { e.printStackTrace(); } } public void testMethod2_02() throws Exception { method2(); } }
我们比较熟悉的Checked异常有 Java.lang.ClassNotFoundException
Java.lang.NoSuchMetodException
java.io.IOException
②RuntimeException Runtime如除数是0和数组下标越界等,其产生频繁,处理麻烦,若显示申明或者捕获将会对程序的可读性和运行效率影响很大。所以由系统自动检测并将它们交给缺省的异常处理程序。当然如果你有处理要求也可以显示捕获它们。
package cn.xy.test; /** * 运行时异常测试方法 * @author xy * */ public class RuntimeExcetionMethods { public void method3() throws RuntimeException { System.out.println("我是抛出运行时异常的方法"); } public void testMethod3_01() { method3(); } public void testMethod1_02() { throw new RuntimeException(); } }
我们比较熟悉的RumtimeException类的子类有 Java.lang.ArithmeticException
Java.lang.ArrayStoreExcetpion
Java.lang.ClassCastException
Java.lang.IndexOutOfBoundsException
Java.lang.NullPointerException
三、Error 当程序发生不可控的错误时,通常做法是通知用户并中止程序的执行。与异常不同的是Error及其子类的对象不应被抛出。 Error是throwable的子类,代表编译时间和系统错误,用于指示合理的应用程序不应该试图捕获的严重问题。 Error由Java虚拟机生成并抛出,包括动态链接失败,虚拟机错误等。程序对其不做处理。 以上这篇java异常继承何类,运行时异常与一般异常的区别(详解)就是小编分享给大家的全部内容了,希望能给大家一个参考,也希望大家多多支持脚本之家。

最新评论

利发国际手机客户端